-- Latches

-- Drop the session if it exists. 
IF EXISTS (
	SELECT * FROM sys.server_event_sessions
		WHERE [name] = N'Latches')
    DROP EVENT SESSION [Latches] ON SERVER
GO

-- Create the event session using dynamic SQL as
-- some wait_type numbers change from version to version
DECLARE @map		INT;
DECLARE @session	NVARCHAR (MAX) =

'CREATE EVENT SESSION [Latches] ON SERVER
ADD EVENT [sqlserver].[latch_suspend_end]
(
    ACTION ([package0].[callstack])
    WHERE ([class] != ';

SELECT @map = [map_key] FROM sys.dm_xe_map_values
WHERE [name] = N'latch_class' AND [map_value] = N'AM_ACCESSOR_CACHE';

SELECT @session = @session + CONVERT (NVARCHAR, @map) + ' AND [class] != ';

SELECT @map = [map_key] FROM sys.dm_xe_map_values
WHERE [name] = N'latch_class' AND [map_value] = N'BACKUP_LOGREDO';

SELECT @session = @session + CONVERT (NVARCHAR, @map) + ' AND [class] != ';

SELECT @map = [map_key] FROM sys.dm_xe_map_values
WHERE [name] = N'latch_class' AND [map_value] = N'BACKUP_OPERATION_LOCK';

SELECT @session = @session + CONVERT (NVARCHAR, @map) + ' AND [class] != ';

SELECT @map = [map_key] FROM sys.dm_xe_map_values
WHERE [name] = N'latch_class' AND [map_value] = N'BACKUP_TAPEPOOL';

SELECT @session = @session + CONVERT (NVARCHAR, @map) + ' AND [class] != ';

SELECT @map = [map_key] FROM sys.dm_xe_map_values
WHERE [name] = N'latch_class' AND [map_value] = N'DATASET_PARENT';

SELECT @session = @session + CONVERT (NVARCHAR, @map) + ' AND [class] != ';

SELECT @map = [map_key] FROM sys.dm_xe_map_values
WHERE [name] = N'latch_class' AND [map_value] = N'DB_MIRRORING_CONNECTION';

SELECT @session = @session + CONVERT (NVARCHAR, @map) + ' AND [class] != ';

SELECT @map = [map_key] FROM sys.dm_xe_map_values
WHERE [name] = N'latch_class' AND [map_value] = N'DB_MIRRORING_REDO_MANAGER';

SELECT @session = @session + CONVERT (NVARCHAR, @map) + ' AND [class] != ';

SELECT @map = [map_key] FROM sys.dm_xe_map_values
WHERE [name] = N'latch_class' AND [map_value] = N'DB_MIRRORING_STREAM';

SELECT @session = @session + CONVERT (NVARCHAR, @map) + ' AND [class] != ';

SELECT @map = [map_key] FROM sys.dm_xe_map_values
WHERE [name] = N'latch_class' AND [map_value] = N'DBCC_CHECK_AGGREGATE';

SELECT @session = @session + CONVERT (NVARCHAR, @map) + ' AND [class] != ';

SELECT @map = [map_key] FROM sys.dm_xe_map_values
WHERE [name] = N'latch_class' AND [map_value] = N'DBCC_CHECK_TABLES_INIT';

SELECT @session = @session + CONVERT (NVARCHAR, @map) + ' AND [class] != ';

SELECT @map = [map_key] FROM sys.dm_xe_map_values
WHERE [name] = N'latch_class' AND [map_value] = N'DBCC_MULTIOBJECT_SCANNER';

SELECT @session = @session + CONVERT (NVARCHAR, @map) + ' AND [class] != ';

SELECT @map = [map_key] FROM sys.dm_xe_map_values
WHERE [name] = N'latch_class' AND [map_value] = N'FGCB_ADDREMOVE';

SELECT @session = @session + CONVERT (NVARCHAR, @map) + ' AND [class] != ';

SELECT @map = [map_key] FROM sys.dm_xe_map_values
WHERE [name] = N'latch_class' AND [map_value] = N'HOBT';

SELECT @session = @session + CONVERT (NVARCHAR, @map) + ' AND [class] != ';

SELECT @map = [map_key] FROM sys.dm_xe_map_values
WHERE [name] = N'latch_class' AND [map_value] = N'HOBT_COUNT';

SELECT @session = @session + CONVERT (NVARCHAR, @map) + ' AND [class] != ';

SELECT @map = [map_key] FROM sys.dm_xe_map_values
WHERE [name] = N'latch_class' AND [map_value] = N'HOBT_VIRTUAL_ROOT';

SELECT @session = @session + CONVERT (NVARCHAR, @map) + ' AND [class] != ';

SELECT @map = [map_key] FROM sys.dm_xe_map_values
WHERE [name] = N'latch_class' AND [map_value] = N'LOG_MANAGER_SPACE';

SELECT @session = @session + CONVERT (NVARCHAR, @map) + ' AND [class] != ';

SELECT @map = [map_key] FROM sys.dm_xe_map_values
WHERE [name] = N'latch_class' AND [map_value] = N'METADATA_CLONE_ACCESS_TICKET';

SELECT @session = @session + CONVERT (NVARCHAR, @map) + ' AND [class] != ';

SELECT @map = [map_key] FROM sys.dm_xe_map_values
WHERE [name] = N'latch_class' AND [map_value] = N'SECURITY_ACCESS_CHECK_CACHE';

SELECT @session = @session + CONVERT (NVARCHAR, @map) + ' AND [class] != ';

SELECT @map = [map_key] FROM sys.dm_xe_map_values
WHERE [name] = N'latch_class' AND [map_value] = N'SPACEMGR_AEC';

SELECT @session = @session + CONVERT (NVARCHAR, @map) + ' AND [class] != ';

SELECT @map = [map_key] FROM sys.dm_xe_map_values
WHERE [name] = N'latch_class' AND [map_value] = N'SSB_MAPPING_MANAGER';

SELECT @session = @session + CONVERT (NVARCHAR, @map) + ' AND [class] != ';

SELECT @map = [map_key] FROM sys.dm_xe_map_values
WHERE [name] = N'latch_class' AND [map_value] = N'TRAN_NESTING_FULL';

SELECT @session = @session + CONVERT (NVARCHAR, @map) + ' AND [class] != ';

SELECT @map = [map_key] FROM sys.dm_xe_map_values
WHERE [name] = N'latch_class' AND [map_value] = N'TRAN_NESTING_RO';

SELECT @session = @session + CONVERT (NVARCHAR, @map) + ' AND [class] != ';

SELECT @map = [map_key] FROM sys.dm_xe_map_values
WHERE [name] = N'latch_class' AND [map_value] = N'XVB_LIST_SCAN';

SELECT @session = @session + CONVERT (NVARCHAR, @map) + ' AND [class] != ';

SELECT @map = [map_key] FROM sys.dm_xe_map_values
WHERE [name] = N'latch_class' AND [map_value] = N'BUF';

SELECT @session = @session + CONVERT (NVARCHAR, @map);

SELECT @session = @session + 
'    )  
)
ADD TARGET [package0].[asynchronous_file_target]
    (SET FILENAME = N''C:\SQLskills\EE_Latches.xel'', 
    METADATAFILE = N''C:\SQLskills\EE_Latches.xem'')
WITH (max_dispatch_latency = 1 seconds)';

EXEC (@session);

-- Start the session
ALTER EVENT SESSION [Latches] ON SERVER
STATE = START;
GO

-- TF to allow call stack resolution
DBCC TRACEON (3656, -1);
GO

-- Run the workload


-- Get the callstacks from the file target
/*
SELECT
	[data].[value] (
		'(/event/data[@name=''class'']/text)[1]', 'VARCHAR(MAX)') AS [Latch Class],
	[data],
	[data].[value] (
		'(/event/action[@name=''callstack'']/value)[1]',
			'VARCHAR(MAX)') AS [Call Stack]
FROM 
	(SELECT CONVERT (XML, [event_data]) AS [data]
	FROM sys.fn_xe_file_target_read_file
		(N'C:\SQLskills\EE_Latches*.xel',
		N'C:\SQLskills\EE_Latches*.xem', null, null)
	) [entries]
GO
*/

-- Now stop the workload

/* Commented out so that the session can be set up by just hitting F5
-- Stop the event session
ALTER EVENT SESSION [Latches] ON SERVER
STATE = STOP;
GO

-- And clean up
IF EXISTS (
	SELECT * FROM sys.server_event_sessions
		WHERE [name] = N'Latches')
    DROP EVENT SESSION [Latches] ON SERVER
GO
*/
