-- Uncommon waits

-- Drop the session if it exists. 
IF EXISTS (
	SELECT * FROM sys.server_event_sessions
		WHERE [name] = N'UncommonWaits')
    DROP EVENT SESSION [UncommonWaits] ON SERVER
GO

-- Create the event session using dynamic SQL as
-- some wait_type numbers change from version to version
DECLARE @map		INT;
DECLARE @session	NVARCHAR (MAX) =

'CREATE EVENT SESSION [UncommonWaits] ON SERVER
ADD EVENT [sqlos].[wait_info]
(
    ACTION ([package0].[callstack])
    WHERE [opcode] = 1		-- Just the end wait events
	AND ([wait_type] != ';

SELECT @map = [map_key] FROM sys.dm_xe_map_values
WHERE [name] = N'wait_types' AND [map_value] = N'ASYNC_DISKPOOL_LOCK';

SELECT @session = @session + CONVERT (NVARCHAR, @map) + ' AND [wait_type] != ';

SELECT @map = [map_key] FROM sys.dm_xe_map_values
WHERE [name] = N'wait_types' AND [map_value] = N'ASYNC_IO_COMPLETION';

SELECT @session = @session + CONVERT (NVARCHAR, @map) + ' AND [wait_type] != ';

SELECT @map = [map_key] FROM sys.dm_xe_map_values
WHERE [name] = N'wait_types' AND [map_value] = N'BACKUP';

SELECT @session = @session + CONVERT (NVARCHAR, @map) + ' AND [wait_type] != ';

SELECT @map = [map_key] FROM sys.dm_xe_map_values
WHERE [name] = N'wait_types' AND [map_value] = N'BACKUPBUFFER';

SELECT @session = @session + CONVERT (NVARCHAR, @map) + ' AND [wait_type] != ';

SELECT @map = [map_key] FROM sys.dm_xe_map_values
WHERE [name] = N'wait_types' AND [map_value] = N'BACKUPIO';

SELECT @session = @session + CONVERT (NVARCHAR, @map) + ' AND [wait_type] != ';

SELECT @map = [map_key] FROM sys.dm_xe_map_values
WHERE [name] = N'wait_types' AND [map_value] = N'BACKUPTHREAD';

SELECT @session = @session + CONVERT (NVARCHAR, @map) + ' AND [wait_type] != ';

SELECT @map = [map_key] FROM sys.dm_xe_map_values
WHERE [name] = N'wait_types' AND [map_value] = N'BROKER_EVENTHANDLER';

SELECT @session = @session + CONVERT (NVARCHAR, @map) + ' AND [wait_type] != ';

SELECT @map = [map_key] FROM sys.dm_xe_map_values
WHERE [name] = N'wait_types' AND [map_value] = N'BROKER_RECEIVE_WAITFOR';

SELECT @session = @session + CONVERT (NVARCHAR, @map) + ' AND [wait_type] != ';

SELECT @map = [map_key] FROM sys.dm_xe_map_values
WHERE [name] = N'wait_types' AND [map_value] = N'BROKER_TO_FLUSH';

SELECT @session = @session + CONVERT (NVARCHAR, @map) + ' AND [wait_type] != ';

SELECT @map = [map_key] FROM sys.dm_xe_map_values
WHERE [name] = N'wait_types' AND [map_value] = N'BROKER_TRANSMITTER';

SELECT @session = @session + CONVERT (NVARCHAR, @map) + ' AND [wait_type] != ';

SELECT @map = [map_key] FROM sys.dm_xe_map_values
WHERE [name] = N'wait_types' AND [map_value] = N'CHECKPOINT_QUEUE';

SELECT @session = @session + CONVERT (NVARCHAR, @map) + ' AND [wait_type] != ';

SELECT @map = [map_key] FROM sys.dm_xe_map_values
WHERE [name] = N'wait_types' AND [map_value] = N'CLR_CRST';

SELECT @session = @session + CONVERT (NVARCHAR, @map) + ' AND [wait_type] != ';

SELECT @map = [map_key] FROM sys.dm_xe_map_values
WHERE [name] = N'wait_types' AND [map_value] = N'CLR_SEMAPHORE';

SELECT @session = @session + CONVERT (NVARCHAR, @map) + ' AND [wait_type] != ';

SELECT @map = [map_key] FROM sys.dm_xe_map_values
WHERE [name] = N'wait_types' AND [map_value] = N'CMEMTHREAD';

SELECT @session = @session + CONVERT (NVARCHAR, @map) + ' AND [wait_type] != ';

SELECT @map = [map_key] FROM sys.dm_xe_map_values
WHERE [name] = N'wait_types' AND [map_value] = N'COMMIT_TABLE';

SELECT @session = @session + CONVERT (NVARCHAR, @map) + ' AND [wait_type] != ';

SELECT @map = [map_key] FROM sys.dm_xe_map_values
WHERE [name] = N'wait_types' AND [map_value] = N'CXPACKET';

SELECT @session = @session + CONVERT (NVARCHAR, @map) + ' AND [wait_type] != ';

SELECT @map = [map_key] FROM sys.dm_xe_map_values
WHERE [name] = N'wait_types' AND [map_value] = N'CXROWSET_SYNC';

IF @map IS NOT NULL
	SELECT @session = @session + CONVERT (NVARCHAR, @map) + ' AND [wait_type] != ';

SELECT @map = [map_key] FROM sys.dm_xe_map_values
WHERE [name] = N'wait_types' AND [map_value] = N'DBMIRROR_DBM_MUTEX';

SELECT @session = @session + CONVERT (NVARCHAR, @map) + ' AND [wait_type] != ';

SELECT @map = [map_key] FROM sys.dm_xe_map_values
WHERE [name] = N'wait_types' AND [map_value] = N'DBMIRROR_SEND';

SELECT @session = @session + CONVERT (NVARCHAR, @map) + ' AND [wait_type] != ';

SELECT @map = [map_key] FROM sys.dm_xe_map_values
WHERE [name] = N'wait_types' AND [map_value] = N'DIRTY_PAGE_POLL';

IF @map IS NOT NULL
	SELECT @session = @session + CONVERT (NVARCHAR, @map) + ' AND [wait_type] != ';

SELECT @map = [map_key] FROM sys.dm_xe_map_values
WHERE [name] = N'wait_types' AND [map_value] = N'DISKIO_SUSPEND';

IF @map IS NOT NULL
	SELECT @session = @session + CONVERT (NVARCHAR, @map) + ' AND [wait_type] != ';

SELECT @map = [map_key] FROM sys.dm_xe_map_values
WHERE [name] = N'wait_types' AND [map_value] = N'DUMP_LOG_COORDINATOR';

SELECT @session = @session + CONVERT (NVARCHAR, @map) + ' AND [wait_type] != ';

SELECT @map = [map_key] FROM sys.dm_xe_map_values
WHERE [name] = N'wait_types' AND [map_value] = N'DUMP_LOG_COORDINATOR_QUEUE';

SELECT @session = @session + CONVERT (NVARCHAR, @map) + ' AND [wait_type] != ';

SELECT @map = [map_key] FROM sys.dm_xe_map_values
WHERE [name] = N'wait_types' AND [map_value] = N'DISPATCHER_QUEUE_SEMAPHORE';

SELECT @session = @session + CONVERT (NVARCHAR, @map) + ' AND [wait_type] != ';

SELECT @map = [map_key] FROM sys.dm_xe_map_values
WHERE [name] = N'wait_types' AND [map_value] = N'EE_PMOLOCK';

SELECT @session = @session + CONVERT (NVARCHAR, @map) + ' AND [wait_type] != ';

SELECT @map = [map_key] FROM sys.dm_xe_map_values
WHERE [name] = N'wait_types' AND [map_value] = N'EXECSYNC';

SELECT @session = @session + CONVERT (NVARCHAR, @map) + ' AND [wait_type] != ';

SELECT @map = [map_key] FROM sys.dm_xe_map_values
WHERE [name] = N'wait_types' AND [map_value] = N'FCB_REPLICA_READ';

SELECT @session = @session + CONVERT (NVARCHAR, @map) + ' AND [wait_type] != ';

SELECT @map = [map_key] FROM sys.dm_xe_map_values
WHERE [name] = N'wait_types' AND [map_value] = N'FCB_REPLICA_WRITE';

SELECT @session = @session + CONVERT (NVARCHAR, @map) + ' AND [wait_type] != ';

SELECT @map = [map_key] FROM sys.dm_xe_map_values
WHERE [name] = N'wait_types' AND [map_value] = N'FFT_RECOVERY';

IF @map IS NOT NULL
	SELECT @session = @session + CONVERT (NVARCHAR, @map) + ' AND [wait_type] != ';

SELECT @map = [map_key] FROM sys.dm_xe_map_values
WHERE [name] = N'wait_types' AND [map_value] = N'FT_IFTSHC_MUTEX';

SELECT @session = @session + CONVERT (NVARCHAR, @map) + ' AND [wait_type] != ';

SELECT @map = [map_key] FROM sys.dm_xe_map_values
WHERE [name] = N'wait_types' AND [map_value] = N'FT_MASTER_MERGE';

SELECT @session = @session + CONVERT (NVARCHAR, @map) + ' AND [wait_type] != ';

SELECT @map = [map_key] FROM sys.dm_xe_map_values
WHERE [name] = N'wait_types' AND [map_value] = N'HADRFS_IOMGR_IOCOMPLETION';

IF @map IS NOT NULL
	SELECT @session = @session + CONVERT (NVARCHAR, @map) + ' AND [wait_type] != ';

SELECT @map = [map_key] FROM sys.dm_xe_map_values
WHERE [name] = N'wait_types' AND [map_value] = N'IO_COMPLETION';

SELECT @session = @session + CONVERT (NVARCHAR, @map) + ' AND [wait_type] != ';

SELECT @map = [map_key] FROM sys.dm_xe_map_values
WHERE [name] = N'wait_types' AND [map_value] = N'KSOURCE_WAKEUP';

SELECT @session = @session + CONVERT (NVARCHAR, @map) + ' AND [wait_type] != ';

SELECT @map = [map_key] FROM sys.dm_xe_map_values
WHERE [name] = N'wait_types' AND [map_value] = N'LATCH_EX';

SELECT @session = @session + CONVERT (NVARCHAR, @map) + ' AND [wait_type] != ';

SELECT @map = [map_key] FROM sys.dm_xe_map_values
WHERE [name] = N'wait_types' AND [map_value] = N'LATCH_SH';

SELECT @session = @session + CONVERT (NVARCHAR, @map) + ' AND [wait_type] != ';

SELECT @map = [map_key] FROM sys.dm_xe_map_values
WHERE [name] = N'wait_types' AND [map_value] = N'LCK_M_IS';

SELECT @session = @session + CONVERT (NVARCHAR, @map) + ' AND [wait_type] != ';

SELECT @map = [map_key] FROM sys.dm_xe_map_values
WHERE [name] = N'wait_types' AND [map_value] = N'LCK_M_IX';

SELECT @session = @session + CONVERT (NVARCHAR, @map) + ' AND [wait_type] != ';

SELECT @map = [map_key] FROM sys.dm_xe_map_values
WHERE [name] = N'wait_types' AND [map_value] = N'LCK_M_S';

SELECT @session = @session + CONVERT (NVARCHAR, @map) + ' AND [wait_type] != ';

SELECT @map = [map_key] FROM sys.dm_xe_map_values
WHERE [name] = N'wait_types' AND [map_value] = N'LCK_M_SCH_M';

SELECT @session = @session + CONVERT (NVARCHAR, @map) + ' AND [wait_type] != ';

SELECT @map = [map_key] FROM sys.dm_xe_map_values
WHERE [name] = N'wait_types' AND [map_value] = N'LCK_M_SCH_S';

SELECT @session = @session + CONVERT (NVARCHAR, @map) + ' AND [wait_type] != ';

SELECT @map = [map_key] FROM sys.dm_xe_map_values
WHERE [name] = N'wait_types' AND [map_value] = N'LCK_M_U';

SELECT @session = @session + CONVERT (NVARCHAR, @map) + ' AND [wait_type] != ';

SELECT @map = [map_key] FROM sys.dm_xe_map_values
WHERE [name] = N'wait_types' AND [map_value] = N'LCK_M_X';

SELECT @session = @session + CONVERT (NVARCHAR, @map) + ' AND [wait_type] != ';

SELECT @map = [map_key] FROM sys.dm_xe_map_values
WHERE [name] = N'wait_types' AND [map_value] = N'LOGBUFFER';

SELECT @session = @session + CONVERT (NVARCHAR, @map) + ' AND [wait_type] != ';

SELECT @map = [map_key] FROM sys.dm_xe_map_values
WHERE [name] = N'wait_types' AND [map_value] = N'LOGMGR_QUEUE';

SELECT @session = @session + CONVERT (NVARCHAR, @map) + ' AND [wait_type] != ';

SELECT @map = [map_key] FROM sys.dm_xe_map_values
WHERE [name] = N'wait_types' AND [map_value] = N'LOGMGR_RESERVE_APPEND';

SELECT @session = @session + CONVERT (NVARCHAR, @map) + ' AND [wait_type] != ';

SELECT @map = [map_key] FROM sys.dm_xe_map_values
WHERE [name] = N'wait_types' AND [map_value] = N'LOGPOOL_CACHESIZE';

SELECT @session = @session + CONVERT (NVARCHAR, @map) + ' AND [wait_type] != ';

SELECT @map = [map_key] FROM sys.dm_xe_map_values
WHERE [name] = N'wait_types' AND [map_value] = N'LOGPOOL_CONSUMER';

SELECT @session = @session + CONVERT (NVARCHAR, @map) + ' AND [wait_type] != ';

SELECT @map = [map_key] FROM sys.dm_xe_map_values
WHERE [name] = N'wait_types' AND [map_value] = N'LOGPOOL_CONSUMERSET';

SELECT @session = @session + CONVERT (NVARCHAR, @map) + ' AND [wait_type] != ';

SELECT @map = [map_key] FROM sys.dm_xe_map_values
WHERE [name] = N'wait_types' AND [map_value] = N'LOGPOOL_FREEPOOLS';

SELECT @session = @session + CONVERT (NVARCHAR, @map) + ' AND [wait_type] != ';

SELECT @map = [map_key] FROM sys.dm_xe_map_values
WHERE [name] = N'wait_types' AND [map_value] = N'LOGPOOL_REPLACEMENTSET';

SELECT @session = @session + CONVERT (NVARCHAR, @map) + ' AND [wait_type] != ';

SELECT @map = [map_key] FROM sys.dm_xe_map_values
WHERE [name] = N'wait_types' AND [map_value] = N'LZW_SLEEP';

SELECT @session = @session + CONVERT (NVARCHAR, @map) + ' AND [wait_type] != ';

SELECT @map = [map_key] FROM sys.dm_xe_map_values
WHERE [name] = N'wait_types' AND [map_value] = N'MSQL_DQ';

SELECT @session = @session + CONVERT (NVARCHAR, @map) + ' AND [wait_type] != ';

SELECT @map = [map_key] FROM sys.dm_xe_map_values
WHERE [name] = N'wait_types' AND [map_value] = N'MSQL_XP';

SELECT @session = @session + CONVERT (NVARCHAR, @map) + ' AND [wait_type] != ';

SELECT @map = [map_key] FROM sys.dm_xe_map_values
WHERE [name] = N'wait_types' AND [map_value] = N'NETWORK_IO';

SELECT @session = @session + CONVERT (NVARCHAR, @map) + ' AND [wait_type] != ';

SELECT @map = [map_key] FROM sys.dm_xe_map_values
WHERE [name] = N'wait_types' AND [map_value] = N'OLEDB';

SELECT @session = @session + CONVERT (NVARCHAR, @map) + ' AND [wait_type] != ';

SELECT @map = [map_key] FROM sys.dm_xe_map_values
WHERE [name] = N'wait_types' AND [map_value] = N'ONDEMAND_TASK_QUEUE';

SELECT @session = @session + CONVERT (NVARCHAR, @map) + ' AND [wait_type] != ';

SELECT @map = [map_key] FROM sys.dm_xe_map_values
WHERE [name] = N'wait_types' AND [map_value] = N'PAGEIOLATCH_EX';

SELECT @session = @session + CONVERT (NVARCHAR, @map) + ' AND [wait_type] != ';

SELECT @map = [map_key] FROM sys.dm_xe_map_values
WHERE [name] = N'wait_types' AND [map_value] = N'PAGEIOLATCH_UP';

SELECT @session = @session + CONVERT (NVARCHAR, @map) + ' AND [wait_type] != ';

SELECT @map = [map_key] FROM sys.dm_xe_map_values
WHERE [name] = N'wait_types' AND [map_value] = N'PAGEIOLATCH_SH';

SELECT @session = @session + CONVERT (NVARCHAR, @map) + ' AND [wait_type] != ';

SELECT @map = [map_key] FROM sys.dm_xe_map_values
WHERE [name] = N'wait_types' AND [map_value] = N'PAGELATCH_EX';

SELECT @session = @session + CONVERT (NVARCHAR, @map) + ' AND [wait_type] != ';

SELECT @map = [map_key] FROM sys.dm_xe_map_values
WHERE [name] = N'wait_types' AND [map_value] = N'PAGELATCH_UP';

SELECT @session = @session + CONVERT (NVARCHAR, @map) + ' AND [wait_type] != ';

SELECT @map = [map_key] FROM sys.dm_xe_map_values
WHERE [name] = N'wait_types' AND [map_value] = N'PAGELATCH_SH';

SELECT @session = @session + CONVERT (NVARCHAR, @map) + ' AND [wait_type] != ';

SELECT @map = [map_key] FROM sys.dm_xe_map_values
WHERE [name] = N'wait_types' AND [map_value] = N'PARALLEL_BACKUP_QUEUE';

IF @map IS NOT NULL
	SELECT @session = @session + CONVERT (NVARCHAR, @map) + ' AND [wait_type] != ';

SELECT @map = [map_key] FROM sys.dm_xe_map_values
WHERE [name] = N'wait_types' AND [map_value] = N'PARALLEL_REDO_WORKER_WAIT_WORK';

IF @map IS NOT NULL
	SELECT @session = @session + CONVERT (NVARCHAR, @map) + ' AND [wait_type] != ';

SELECT @map = [map_key] FROM sys.dm_xe_map_values
WHERE [name] = N'wait_types' AND [map_value] = N'PARALLEL_REDO_WORKER_SYNC';

IF @map IS NOT NULL
	SELECT @session = @session + CONVERT (NVARCHAR, @map) + ' AND [wait_type] != ';

SELECT @map = [map_key] FROM sys.dm_xe_map_values
WHERE [name] = N'wait_types' AND [map_value] = N'PERFORMANCE_COUNTERS_RWLOCK';

SELECT @session = @session + CONVERT (NVARCHAR, @map) + ' AND [wait_type] != ';

SELECT @map = [map_key] FROM sys.dm_xe_map_values
WHERE [name] = N'wait_types' AND [map_value] = N'PRINT_ROLLBACK_PROGRESS';

SELECT @session = @session + CONVERT (NVARCHAR, @map) + ' AND [wait_type] != ';

SELECT @map = [map_key] FROM sys.dm_xe_map_values
WHERE [name] = N'wait_types' AND [map_value] = N'QDS_ASYNC_QUEUE';

IF @map IS NOT NULL
	SELECT @session = @session + CONVERT (NVARCHAR, @map) + ' AND [wait_type] != ';

SELECT @map = [map_key] FROM sys.dm_xe_map_values
WHERE [name] = N'wait_types' AND [map_value] = N'QDS_CLEANUP_STALE_QUERIES_TASK_MAIN_LOOP_SLEEP';

IF @map IS NOT NULL
	SELECT @session = @session + CONVERT (NVARCHAR, @map) + ' AND [wait_type] != ';

SELECT @map = [map_key] FROM sys.dm_xe_map_values
WHERE [name] = N'wait_types' AND [map_value] = N'QDS_PERSIST_TASK_MAIN_LOOP_SLEEP';

IF @map IS NOT NULL
	SELECT @session = @session + CONVERT (NVARCHAR, @map) + ' AND [wait_type] != ';

SELECT @map = [map_key] FROM sys.dm_xe_map_values
WHERE [name] = N'wait_types' AND [map_value] = N'QDS_SHUTDOWN_QUEUE';

IF @map IS NOT NULL
	SELECT @session = @session + CONVERT (NVARCHAR, @map) + ' AND [wait_type] != ';

SELECT @map = [map_key] FROM sys.dm_xe_map_values
WHERE [name] = N'wait_types' AND [map_value] = N'REQUEST_DISPENSER_PAUSE';

SELECT @session = @session + CONVERT (NVARCHAR, @map) + ' AND [wait_type] != ';

SELECT @map = [map_key] FROM sys.dm_xe_map_values
WHERE [name] = N'wait_types' AND [map_value] = N'REQUEST_FOR_DEADLOCK_SEARCH';

SELECT @session = @session + CONVERT (NVARCHAR, @map) + ' AND [wait_type] != ';

SELECT @map = [map_key] FROM sys.dm_xe_map_values
WHERE [name] = N'wait_types' AND [map_value] = N'RESOURCE_SEMAPHORE';

SELECT @session = @session + CONVERT (NVARCHAR, @map) + ' AND [wait_type] != ';

SELECT @map = [map_key] FROM sys.dm_xe_map_values
WHERE [name] = N'wait_types' AND [map_value] = N'RESOURCE_SEMAPHORE_MUTEX';

SELECT @session = @session + CONVERT (NVARCHAR, @map) + ' AND [wait_type] != ';

SELECT @map = [map_key] FROM sys.dm_xe_map_values
WHERE [name] = N'wait_types' AND [map_value] = N'RESOURCE_SEMAPHORE_QUERY_COMPILE';

SELECT @session = @session + CONVERT (NVARCHAR, @map) + ' AND [wait_type] != ';

SELECT @map = [map_key] FROM sys.dm_xe_map_values
WHERE [name] = N'wait_types' AND [map_value] = N'SLEEP_BPOOL_FLUSH';

SELECT @session = @session + CONVERT (NVARCHAR, @map) + ' AND [wait_type] != ';

SELECT @map = [map_key] FROM sys.dm_xe_map_values
WHERE [name] = N'wait_types' AND [map_value] = N'SLEEP_TASK';

SELECT @session = @session + CONVERT (NVARCHAR, @map) + ' AND [wait_type] != ';

SELECT @map = [map_key] FROM sys.dm_xe_map_values
WHERE [name] = N'wait_types' AND [map_value] = N'SOS_PHYS_PAGE_CACHE';

IF @map IS NOT NULL
	SELECT @session = @session + CONVERT (NVARCHAR, @map) + ' AND [wait_type] != ';

SELECT @map = [map_key] FROM sys.dm_xe_map_values
WHERE [name] = N'wait_types' AND [map_value] = N'SOS_SCHEDULER_YIELD';

SELECT @session = @session + CONVERT (NVARCHAR, @map) + ' AND [wait_type] != ';

SELECT @map = [map_key] FROM sys.dm_xe_map_values
WHERE [name] = N'wait_types' AND [map_value] = N'SOS_SYNC_TASK_ENQUEUE_EVENT';

SELECT @session = @session + CONVERT (NVARCHAR, @map) + ' AND [wait_type] != ';

SELECT @map = [map_key] FROM sys.dm_xe_map_values
WHERE [name] = N'wait_types' AND [map_value] = N'SOS_WORKER';

SELECT @session = @session + CONVERT (NVARCHAR, @map) + ' AND [wait_type] != ';

SELECT @map = [map_key] FROM sys.dm_xe_map_values
WHERE [name] = N'wait_types' AND [map_value] = N'SP_SERVER_DIAGNOSTICS_SLEEP';

IF @map IS NOT NULL
	SELECT @session = @session + CONVERT (NVARCHAR, @map) + ' AND [wait_type] != ';

SELECT @map = [map_key] FROM sys.dm_xe_map_values
WHERE [name] = N'wait_types' AND [map_value] = N'SQLCLR_APPDOMAIN';

SELECT @session = @session + CONVERT (NVARCHAR, @map) + ' AND [wait_type] != ';

SELECT @map = [map_key] FROM sys.dm_xe_map_values
WHERE [name] = N'wait_types' AND [map_value] = N'SQLCLR_ASSEMBLY';

SELECT @session = @session + CONVERT (NVARCHAR, @map) + ' AND [wait_type] != ';

SELECT @map = [map_key] FROM sys.dm_xe_map_values
WHERE [name] = N'wait_types' AND [map_value] = N'SQLTRACE_FILE_BUFFER';

SELECT @session = @session + CONVERT (NVARCHAR, @map) + ' AND [wait_type] != ';

SELECT @map = [map_key] FROM sys.dm_xe_map_values
WHERE [name] = N'wait_types' AND [map_value] = N'SQLTRACE_INCREMENTAL_FLUSH_SLEEP';

SELECT @session = @session + CONVERT (NVARCHAR, @map) + ' AND [wait_type] != ';

SELECT @map = [map_key] FROM sys.dm_xe_map_values
WHERE [name] = N'wait_types' AND [map_value] = N'SSB_TASK_STOP';

SELECT @session = @session + CONVERT (NVARCHAR, @map) + ' AND [wait_type] != ';

SELECT @map = [map_key] FROM sys.dm_xe_map_values
WHERE [name] = N'wait_types' AND [map_value] = N'WAITFOR';

SELECT @session = @session + CONVERT (NVARCHAR, @map) + ' AND [wait_type] != ';

SELECT @map = [map_key] FROM sys.dm_xe_map_values
WHERE [name] = N'wait_types' AND [map_value] = N'WRITE_COMPLETION';

SELECT @session = @session + CONVERT (NVARCHAR, @map) + ' AND [wait_type] != ';

SELECT @map = [map_key] FROM sys.dm_xe_map_values
WHERE [name] = N'wait_types' AND [map_value] = N'WRITELOG';

SELECT @session = @session + CONVERT (NVARCHAR, @map) + ' AND [wait_type] != ';

SELECT @map = [map_key] FROM sys.dm_xe_map_values
WHERE [name] = N'wait_types' AND [map_value] = N'XE_BUFFERMGR_ALLPROCESSED_EVENT';

SELECT @session = @session + CONVERT (NVARCHAR, @map) + ' AND [wait_type] != ';

SELECT @map = [map_key] FROM sys.dm_xe_map_values
WHERE [name] = N'wait_types' AND [map_value] = N'XE_TIMER_EVENT';

SELECT @session = @session + CONVERT (NVARCHAR, @map) + ' AND [wait_type] != ';

SELECT @map = [map_key] FROM sys.dm_xe_map_values
WHERE [name] = N'wait_types' AND [map_value] = N'XE_TIMER_MUTEX';

SELECT @session = @session + CONVERT (NVARCHAR, @map) + ' AND [wait_type] != ';

SELECT @map = [map_key] FROM sys.dm_xe_map_values
WHERE [name] = N'wait_types' AND [map_value] = N'XTP_CKPT_CLOSE';

IF @map IS NOT NULL
	SELECT @session = @session + CONVERT (NVARCHAR, @map) + ' AND [wait_type] != ';

SELECT @map = [map_key] FROM sys.dm_xe_map_values
WHERE [name] = N'wait_types' AND [map_value] = N'XTP_HOST_WAIT';

IF @map IS NOT NULL
	SELECT @session = @session + CONVERT (NVARCHAR, @map) + ' AND [wait_type] != ';

SELECT @map = [map_key] FROM sys.dm_xe_map_values
WHERE [name] = N'wait_types' AND [map_value] = N'XTP_OFFLINE_CKPT_LOG_IO';

IF @map IS NOT NULL
	SELECT @session = @session + CONVERT (NVARCHAR, @map) + ' AND [wait_type] != ';

SELECT @map = [map_key] FROM sys.dm_xe_map_values
WHERE [name] = N'wait_types' AND [map_value] = N'XTP_OFFLINE_CKPT_LOG_NEW_LOG';

IF @map IS NOT NULL
	SELECT @session = @session + CONVERT (NVARCHAR, @map) + ' AND [wait_type] != ';

SELECT @map = [map_key] FROM sys.dm_xe_map_values
WHERE [name] = N'wait_types' AND [map_value] = N'XTP_RECOVERY';

IF @map IS NOT NULL
	SELECT @session = @session + CONVERT (NVARCHAR, @map) + ' AND [wait_type] != ';

SELECT @map = [map_key] FROM sys.dm_xe_map_values
WHERE [name] = N'wait_types' AND [map_value] = N'XTP_TASK_SHUTDOWN';

IF @map IS NOT NULL
	SELECT @session = @session + CONVERT (NVARCHAR, @map) + ' AND [wait_type] != ';

SELECT @map = [map_key] FROM sys.dm_xe_map_values
WHERE [name] = N'wait_types' AND [map_value] = N'SLEEP_SYSTEMTASK';

SELECT @session = @session + CONVERT (NVARCHAR, @map);

SELECT @session = @session + 
'    )  
)
ADD TARGET [package0].[asynchronous_file_target]
    (SET FILENAME = N''C:\SQLskills\EE_UncommonWaits.xel'', 
    METADATAFILE = N''C:\SQLskills\EE_UncommonWaits.xem'')
WITH (max_dispatch_latency = 1 seconds)';

EXEC (@session);

-- Start the session
ALTER EVENT SESSION [UncommonWaits] ON SERVER
STATE = START;
GO

-- TF to allow call stack resolution
DBCC TRACEON (3656, -1);
GO

-- Run the workload

-- Get the callstacks from the file target
/*
SELECT
*
FROM
(SELECT
	[data].[value] (
		'(/event/data[@name=''wait_type'']/text)[1]', 'VARCHAR(MAX)') AS [Wait Type],
	[data],
	[data].[value] (
		'(/event/action[@name=''callstack'']/value)[1]',
			'VARCHAR(MAX)') AS [Call Stack]
FROM 
	(SELECT CONVERT (XML, [event_data]) AS [data]
	FROM sys.fn_xe_file_target_read_file
		(N'C:\SQLskills\EE_UncommonWaits*.xel',
		N'C:\SQLskills\EE_UncommonWaits*.xem', null, null)
	) [entries]
) [a]
WHERE [Wait Type] != 'invalid'
ORDER BY [Wait Type]
GO
*/

/* Commented out so that the session can be set up by just hitting F5
-- Now stop the workload

-- Stop the event session
ALTER EVENT SESSION [UncommonWaits] ON SERVER
STATE = STOP;
GO

-- And clean up
IF EXISTS (
	SELECT * FROM sys.server_event_sessions
		WHERE [name] = N'UncommonWaits')
    DROP EVENT SESSION [UncommonWaits] ON SERVER
GO
*/